==== Patch <doxygen-1.5.6svn-manual-inheritance-doc> level 2
Source: 753fe47b-1580-4fbf-99b0-fe3a23bba955:/local/doxygen/manual-inheritance:658 [local]
Target: afe2bf4a-e733-0410-8a33-86f594647bc7:/trunk:643 [mirrored]
        (https://doxygen.svn.sourceforge.net/svnroot/doxygen)
Log:
 r657@misuzu:  juliano | 2008-07-31 20:45:04 -0300
 Manual inheritance documentation update.
 
 Added documentation for \private, \protected and \public commands, since they
 are now allowed (and useful) for manual inheritance using \memberof.

=== doc/commands.doc
==================================================================
--- doc/commands.doc	(revision 643)
+++ doc/commands.doc	(patch doxygen-1.5.6svn-manual-inheritance-doc level 2)
@@ -127,14 +127,14 @@
 \refitem cmdparam \\param
 \refitem cmdpost \\post
 \refitem cmdpre \\pre
-\refitem cmd_php_only \\private (PHP only)
-\refitem cmd_php_only \\privatesection (PHP only)
+\refitem cmdprivate \\private
+\refitem cmdprivate \\privatesection
 \refitem cmdproperty \\property
-\refitem cmd_php_only \\protected (PHP only)
-\refitem cmd_php_only \\protectedsection (PHP only)
+\refitem cmdprotected \\protected
+\refitem cmdprotected \\protectedsection
 \refitem cmdprotocol \\protocol
-\refitem cmd_php_only \\public (PHP only)
-\refitem cmd_php_only \\publicsection (PHP only)
+\refitem cmdpublic \\public
+\refitem cmdpublic \\publicsection
 \refitem cmdref \\ref
 \refitem cmdrelates \\relates
 \refitem cmdrelatesalso \\relatesalso
@@ -575,6 +575,10 @@
   is represented as a real member of the class.
   This can be useful when the programming language does not support 
   the concept of member functions natively (e.g. C).
+
+  It is also possible to use this command together with
+  \ref cmdpublic "\\public", \ref cmdprotected "\\protected" or
+  \ref cmdprivate "\\private".
  
   The file \c manual.c in the example directory shows how to use this command.
   \htmlonly
@@ -582,8 +586,9 @@
   for the corresponding HTML documentation that is generated by doxygen.
   \endhtmlonly
 
-  \sa section \ref cmdextends "\\extends" and section
-      \ref cmdmemberof "\\memberof"
+  \sa sections \ref cmdextends "\\extends", \ref cmdimplements "\\implements",
+      \ref cmdpublic "\\public", \ref cmdprotected "\\protected" and
+      \ref cmdprivate "\\private".
 
 <hr>
 \section cmdname \\name (header)  
@@ -683,6 +688,25 @@
               \ref cmdref "\\ref".
 
 <hr>
+\section cmdprivate \\private
+
+  \addindex \\private
+  \addindex \\privatesection
+  Indicates that the member documented in the comment block is private,
+  i.e., should only be accessed by other members in the same class.
+
+  Note that Doxygen automatically detects the protection level of members
+  in object-oriented languages. This command is intended for use only when
+  the language does not support the concept of protection level natively
+  (e.g. C, PHP 4).
+
+  For starting a section of private members, in a way similar to the
+  "private:" class marker in C++, use \\privatesection.
+
+  \sa sections \ref cmdmemberof "\\memberof", \ref cmdpublic "\\public",
+      and \ref cmdprotected "\\protected".
+
+<hr>
 \section cmdproperty \\property (qualified property name)
 
   \addindex \\property
@@ -693,6 +717,26 @@
   \sa section \ref cmdfn "\\fn" and \ref cmdvar "\\var".
 
 <hr>
+\section cmdprotected \\protected
+
+  \addindex \\protected
+  \addindex \\protectedsection
+  Indicates that the member documented in the comment block is protected,
+  i.e., should only be accessed by other members in the same or derived
+  classes.
+
+  Note that Doxygen automatically detects the protection level of members
+  in object-oriented languages. This command is intended for use only when
+  the language does not support the concept of protection level natively
+  (e.g. C, PHP 4).
+
+  For starting a section of protected members, in a way similar to the
+  "protected:" class marker in C++, use \\protectedsection.
+
+  \sa sections \ref cmdmemberof "\\memberof", \ref cmdpublic "\\public",
+      and \ref cmdprivate "\\private".
+
+<hr>
 \section cmdprotocol \\protocol <name> [<header-file>] [<header-name>]
 
   \addindex \\protocol
@@ -703,6 +747,25 @@
   \sa section \ref cmdclass "\\class".
 
 <hr>
+\section cmdpublic \\public
+
+  \addindex \\public
+  \addindex \\publicsection
+  Indicates that the member documented in the comment block is public,
+  i.e., can be accessed by any other class or function.
+
+  Note that Doxygen automatically detects the protection level of members
+  in object-oriented languages. This command is intended for use only when
+  the language does not support the concept of protection level natively
+  (e.g. C, PHP 4).
+
+  For starting a section of public members, in a way similar to the
+  "public:" class marker in C++, use \\publicsection.
+
+  \sa sections \ref cmdmemberof "\\memberof", \ref cmdprotected "\\protected"
+      and \ref cmdprivate "\\private".
+
+<hr>
 \section cmdrelates \\relates <name>
 
   \addindex \\relates
@@ -2369,18 +2432,6 @@
   character has to be escaped in some cases, because it is used to 
   prevent auto-linking to word that is also a documented class or struct. 
 
-<hr>
-\section cmd_php_only PHP only commands
-For PHP files there are a number of additional commands, that can be
-used inside classes to make members public, private, or protected even
-though the language itself doesn't support this notion.
-
-To mark a single item use one of \\private, \\protected, \\public.
-For starting a section with a certain protection level use one of:
-\\privatesection, \\protectedsection, \\publicsection.
-The latter commands are similar to 
-"private:", "protected:", and "public:" in C++.
-
 <h2>\htmlonly <center> --- \endhtmlonly 
     Commands included for Qt compatibility
     \htmlonly --- </center>\endhtmlonly</h2>